# preparing tarball:
# git clone https://github.com/jeremyb31/mouse-4.15
# tar.xz

%global		module	mouse
%global		pname	%{module}415

Name:		dkms-%{pname}
Version:	4.20.0
Release:	%mkrel 2
Source0:	%{pname}-%{version}.tar.xz
##Patch0:		
License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/jeremyb31/mouse-4.15
Summary:	dkms driver for trackpoints/-pads to use with kernel >= 4.19.. 
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Provides:	%{name}-%{version}
Requires(preun,post): dkms
Requires:   gcc >= 9.2.0
Obsoletes:	%{name} <= %{version} 

%description -n %{name}
Linux mouse-drivers from kver-4.15 to provide functions
also on newer kver >= 4.19...
obj-$(CONFIG_MOUSE_AMIGA)		+= amimouse.o
obj-$(CONFIG_MOUSE_APPLETOUCH)		+= appletouch.o
obj-$(CONFIG_MOUSE_ATARI)		+= atarimouse.o
obj-$(CONFIG_MOUSE_BCM5974)		+= bcm5974.o
obj-$(CONFIG_MOUSE_CYAPA)		+= cyapatp.o
obj-$(CONFIG_MOUSE_ELAN_I2C)		+= elan_i2c.o
obj-$(CONFIG_MOUSE_GPIO)		+= gpio_mouse.o
obj-$(CONFIG_MOUSE_INPORT)		+= inport.o
obj-$(CONFIG_MOUSE_LOGIBM)		+= logibm.o
obj-$(CONFIG_MOUSE_MAPLE)		+= maplemouse.o
obj-$(CONFIG_MOUSE_NAVPOINT_PXA27x)	+= navpoint.o
obj-$(CONFIG_MOUSE_PC110PAD)		+= pc110pad.o
obj-$(CONFIG_MOUSE_PS2)			+= psmouse.o
obj-$(CONFIG_MOUSE_PXA930_TRKBALL)	+= pxa930_trkball.o
obj-$(CONFIG_MOUSE_RISCPC)		+= rpcmouse.o
obj-$(CONFIG_MOUSE_SERIAL)		+= sermouse.o
obj-$(CONFIG_MOUSE_SYNAPTICS_I2C)	+= synaptics_i2c.o
obj-$(CONFIG_MOUSE_SYNAPTICS_USB)	+= synaptics_usb.o
obj-$(CONFIG_MOUSE_VSXXXAA)		+= vsxxxaa.o

cyapatp-objs := cyapa.o cyapa_gen3.o cyapa_gen5.o cyapa_gen6.o
psmouse-objs := psmouse-base.o synaptics.o focaltech.o

psmouse-$(CONFIG_MOUSE_PS2_ALPS)	+= alps.o
psmouse-$(CONFIG_MOUSE_PS2_BYD)		+= byd.o
psmouse-$(CONFIG_MOUSE_PS2_ELANTECH)	+= elantech.o
psmouse-$(CONFIG_MOUSE_PS2_OLPC)	+= hgpk.o
psmouse-$(CONFIG_MOUSE_PS2_LOGIPS2PP)	+= logips2pp.o
psmouse-$(CONFIG_MOUSE_PS2_LIFEBOOK)	+= lifebook.o
psmouse-$(CONFIG_MOUSE_PS2_SENTELIC)	+= sentelic.o
psmouse-$(CONFIG_MOUSE_PS2_TRACKPOINT)	+= trackpoint.o
psmouse-$(CONFIG_MOUSE_PS2_TOUCHKIT)	+= touchkit_ps2.o
psmouse-$(CONFIG_MOUSE_PS2_CYPRESS)	+= cypress_ps2.o
psmouse-$(CONFIG_MOUSE_PS2_VMMOUSE)	+= vmmouse.o

psmouse-$(CONFIG_MOUSE_PS2_SMBUS)	+= psmouse-smbus.o

elan_i2c-objs := elan_i2c_core.o
elan_i2c-$(CONFIG_MOUSE_ELAN_I2C_I2C)	+= elan_i2c_i2c.o
elan_i2c-$(CONFIG_MOUSE_ELAN_I2C_SMBUS)	+= elan_i2c_smbus.o

%prep
%setup -qn %{pname}-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a ./* %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{README.md}
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME=%{pname}
PACKAGE_VERSION=%{version}-%{release}
MAKE="'make' SKIP_STACK_VALIDATION=1 all"
BUILT_MODULE_NAME[0]="appletouch"
BUILT_MODULE_NAME[1]="bcm5974"
BUILT_MODULE_NAME[2]="cyapatp"
BUILT_MODULE_NAME[3]="elan_i2c"
BUILT_MODULE_NAME[4]="gpio_mouse"
BUILT_MODULE_NAME[5]="psmouse"
BUILT_MODULE_NAME[6]="sermouse"
BUILT_MODULE_NAME[7]="synaptics_i2c"
BUILT_MODULE_NAME[8]="synaptics_usb"
BUILT_MODULE_NAME[9]="vsxxxaa"
DEST_MODULE_NAME[0]="appletouch"
DEST_MODULE_NAME[1]="bcm5974"
DEST_MODULE_NAME[2]="cyapatp"
DEST_MODULE_NAME[3]="elan_i2c"
DEST_MODULE_NAME[4]="gpio_mouse"
DEST_MODULE_NAME[5]="psmouse"
DEST_MODULE_NAME[6]="sermouse"
DEST_MODULE_NAME[7]="synaptics_i2c"
DEST_MODULE_NAME[8]="synaptics_usb"
DEST_MODULE_NAME[9]="vsxxxaa"
BUILT_MODULE_LOCATION[0]="./"
BUILT_MODULE_LOCATION[1]="./"
BUILT_MODULE_LOCATION[2]="./"
BUILT_MODULE_LOCATION[3]="./"
BUILT_MODULE_LOCATION[4]="./"
BUILT_MODULE_LOCATION[5]="./"
BUILT_MODULE_LOCATION[6]="./"
BUILT_MODULE_LOCATION[7]="./"
BUILT_MODULE_LOCATION[8]="./"
BUILT_MODULE_LOCATION[9]="./"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/%{pname}"
DEST_MODULE_LOCATION[1]="/kernel/3rdparty/%{pname}"
DEST_MODULE_LOCATION[2]="/kernel/3rdparty/%{pname}"
DEST_MODULE_LOCATION[3]="/kernel/3rdparty/%{pname}"
DEST_MODULE_LOCATION[4]="/kernel/3rdparty/%{pname}"
DEST_MODULE_LOCATION[5]="/kernel/3rdparty/%{pname}"
DEST_MODULE_LOCATION[6]="/kernel/3rdparty/%{pname}"
DEST_MODULE_LOCATION[7]="/kernel/3rdparty/%{pname}"
DEST_MODULE_LOCATION[8]="/kernel/3rdparty/%{pname}"
DEST_MODULE_LOCATION[9]="/kernel/3rdparty/%{pname}"
AUTOINSTALL="yes"
CLEAN="make clean"
EOF

%post -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}
true
II="appletouch
cyapatp
gpio_mouse
sermouse
synaptics_usb
bcm5974
elan_i2c
psmouse
synaptics_i2c
vsxxxaa
"
for i in $II
do
/sbin/rmmod $i >/dev/null 2>&1
sleep 1
/sbin/modprobe $i
done

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all
true
oo="appletouch
cyapatp
gpio_mouse
sermouse
synaptics_usb
bcm5974
elan_i2c
psmouse
synaptics_i2c
vsxxxaa
"
for i in $oo
do
/sbin/rmmod $i >/dev/null 2>&1
sleep 1
/sbin/modprobe $i
done

## remove module-destdir just if it empty after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/%{pname} >/dev/null 2>&1
fi


%clean
%__rm -rf %{buildroot}

%files -n %{name}
%defattr(-,root,root)
%doc README.md
%{_usrsrc}/%{pname}-%{version}-%{release}/*

%changelog
* Tue Aug 13 2019 tex - 4.20.0-2pclos2019
- rebuild against updates

* Wed Jan 02 2018 onkelho <oh.quait at gmail.com> - 4.20.0-1pclos2019
- initial build

